//+----------------------------------------------+
//|                                 Open BuySell |
//+----------------------------------------------+
//*
//* my_DailyOpen_indicator
//*
//* Revision 1.1  2005/11/13 Midnite
//* Initial DailyOpen indicator
//* based pm  
//*
//#property copyright "Midnite"
//#property link      "me@home.net"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_style1 0
#property indicator_style2 4
#property indicator_style3 4


extern int TimeZoneOfData      = 0;
extern int LevelAboveBelowOpen = 50;

double TodayOpenBuffer[];
double TodayOpenBufferHI[];
double TodayOpenBufferLO[];

double myPoint;

double SetPoint() 
{ 
   double mPoint; 
   
   if (Digits < 4) 
   mPoint = 0.01; 
   else 
   mPoint = 0.0001; 
   
  return(mPoint); 
}  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(2);
   
	SetIndexStyle(0,DRAW_LINE);
	SetIndexBuffer(0,TodayOpenBuffer);
	SetIndexLabel(0,"Open");
	SetIndexEmptyValue(0,0.0);
	
	SetIndexStyle(1,DRAW_LINE);
	SetIndexBuffer(1,TodayOpenBufferHI);
	SetIndexLabel(1,"Upper");
	SetIndexEmptyValue(1,0.0);
	
	SetIndexStyle(2,DRAW_LINE);
	SetIndexBuffer(2,TodayOpenBufferLO);
	SetIndexLabel(2,"Lower");
	SetIndexEmptyValue(2,0.0);
	
	myPoint = SetPoint();
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int lastbar;
   int counted_bars= IndicatorCounted();
   
   if (counted_bars>0) counted_bars--;
   lastbar = Bars-counted_bars;	
   DailyOpen(0,lastbar);
   
   return (0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int DailyOpen(int offset, int lastbar)
{
   int shift;
   int tzdiffsec= TimeZoneOfData * 3600;
   double barsper30= 1.0*PERIOD_M30/Period();
   bool ShowDailyOpenLevel= True;
   // lastbar+= barsperday+2;  // make sure we catch the daily open		 
   lastbar= MathMin(Bars-20*barsper30-1, lastbar);

	for(shift=lastbar;shift>=offset;shift--){
	  TodayOpenBuffer[shift]= 0;
     if (ShowDailyOpenLevel){
       if(TimeDayOfWeek(Time[shift]-tzdiffsec) != TimeDayOfWeek(Time[shift+1]-tzdiffsec)){      // day change
         TodayOpenBuffer[shift]= Open[shift];         
         TodayOpenBuffer[shift+1]= 0;  
         TodayOpenBufferHI[shift]= Open[shift]+LevelAboveBelowOpen*myPoint;         
         TodayOpenBufferHI[shift+1]= 0;   
         TodayOpenBufferLO[shift]= Open[shift]-LevelAboveBelowOpen*myPoint;         
         TodayOpenBufferLO[shift+1]= 0;                                                            // avoid stairs in the line
       }
       else{
         TodayOpenBuffer[shift]= TodayOpenBuffer[shift+1];
         TodayOpenBufferHI[shift]= TodayOpenBufferHI[shift+1];
         TodayOpenBufferLO[shift]= TodayOpenBufferLO[shift+1];
       }
	  }
   }
   return(0);
}